Smart II Software parameters: Card parameters
=============================================            
                                               LSS 5.0(0), August 1996
                                               -----------------------
1 Introduction
--------------

This  document describes those parameters that affect the operation of 
a  particular  Ringnode in your workstation, but  not  of  a  specific 
interface.

There  are  two  types  of  card  parameter.  The first relates to the 
hardware, an example is the IO.LOCATION parameter. The second  relates 
to  the kernel software (an integral part of SMART.EXE), an example is 
the FRAME.SIZE parameter.  For a list of the different parameters  and 
an  indication  of  whether  they relate to the hardware or the kernel 
software, see Table 1.

If you are using SMART.CFG to configure your Smart II  Software,  then 
you  must place all of the Card parameters that relate to the hardware 
of a particular Ringnode at the top of  a  [CARD]  section  (that  is, 
before  any  protocol  sections).   You can place Card parameters that 
relate to the kernel software either at the top of  a  [CARD]  section 
(along  with  the  hardware  parameters),  or  if you are using an LLC 
interface, in the [LLC] section.

Table 1 gives a list of all Card parameters and indicates whether they 
relate to Ringnode hardware or kernel software.  A full description of 
each of the parameters is given in Section 2.

      +------------------------------------------+
      |                                          |
      | Parameter       (Abbrev)          Type   |
      | ---------       --------          ----   |
      |                                          |
      | PIO                ()           hardware |
      | USEDMA             ()           hardware |
      | LOMEM              ()           hardware |
      | ALTIO              ()           hardware |
      | MMIO               ()           hardware |
      | IO.LOCATION        (IO)         hardware |
      | SLOT               ()           hardware |
      | IRQ                ()           hardware |                      
      | ALTERNATE          (REV3)       hardware |
      | BURNT.IN.ADDRESS   (BIA)        hardware |
      |                                          |
      | NODE.ADDRESS       (NA)         software |
      | FRAME.SIZE         (FS)         software |
      | SAPS               (SA)         software |
      | EXTRA.SAPS         (ES)         software |
      | GROUP.SAPS         (GS)         software |
      | STATIONS           (ST)         software |
      | EXTRA.STATIONS     (EST)        software |
      | DEF.T1             (DT1)        software |
      | DEF.T2             (DT2)        software |
      | DEF.TI             (DTI)        software |
      | DEF.MAXOUT         (DMO)        software |
      | DEF.MAXIN          (DMI)        software |
      | DEF.MAXOUT.INCR    (DMOI)       software |
      | DEF.RETRY.COUNT    (DRC)        software |
      |                                          |
      +------------------------------------------+
                                                
        Table 1. Card parameters.

Figure 1 displays part of a SMART.CFG which demonstrates some  of  the 
card  parameters. The hardware parameters are at the top of the [CARD] 
sections; the kernel software parameters are at the top of the  [CARD] 
section for the first card, and in the [LLC] section for the second.

      +------------------------------------------+      
      |                                          |
      | [HOST]                                   |
      |                                          |
      |   :             ; host parameters here   |
      |                                          |
      |  [CARD]         ; first card section     |
      |                                          |
      |                                          |
      |   io=a20        ; io location is a20     |
      |   lomem         ; use lomem transfer     |
      |                                          |
      |   fs=1024       ; frame size is 1K bytes |
      |   sa=25         ; 25 saps                |
      |   es=25         ; 25 extra saps          |
      |                                          |
      |   [IPX]         ; install the IPX i/f    |
      |                                          |
      |  [CARD]         ; second card section    |
      |                                          |
      |   io=1a20       ; io location is 1a20    |
      |                                          |
      |   [LLC]         ; install the LLC i/f    |
      |                                          |
      |    fs=4096      ; frame size is 4K       |
      |    sa=20        ; 20 saps                |
      |                                          |
      +------------------------------------------+      

        Figure 1. Example SMART.CFG.

If you are configuring your Smart II Software from  the  command line, 
then  you must use commas to separate parameters relating to different 
Ringnodes.  The following sample command line installs  IPX  onto  one 
Ringnode  using  a frame-size of 4K; it also installs NetBIOS onto the 
Ringnode at IO location 3A20 :

        SMART FS=4096 IPX, IO=3A20 NETB

2 Card parameters
-----------------

This section describes the Card parameters.  Abbreviations  are  given 
for those parameters that can be shortened.

PIO                 Enables the fast  16-bit  PIO  (Programmed  Input/ 
                    Output) mode of data transfer on your Ringnode (if 
                    this is available). The Smart 16/4 AT, ISA Client, 
                    AT Plus Ringnodes, the Smart 16 Ringnode, and  the 
                    PCMCIA  Ringnode  support  16-bit  PIO  transfers; 
                    The  Smart 16/4  EISA, MC, MC32  Ringnode  support
		    only DMA.
                    
                    If you are using Windows, or any memory management 
                    software,  the  process  of  copying DMA exchanges 
                    through buffers in conventional memory (see LOMEM) 
                    may reduce  the  speed  of  performance.  If  your 
                    computer  has  fast clock- and bus-speeds, you may 
                    find that PIO gives you the best performance.  

LOMEM               Ensures that all data sent by DMA  (Direct  Memory 
                    Access)  to  and  from  your  Ringnode,  is copied 
                    through  a  buffer  in  conventional  memory  that 
                    cannot  be  re-mapped  by  Windows or other memory 
                    management software. 
                    
                    DMA allows your Ringnode to exchange data directly 
                    with   your   computer's   memory,   without   the 
                    intervention of the microprocessor.  If  a  memory 
                    manager  re-maps  the  part of PC memory that your 
                    Ringnode is trying to communicate with, the  Smart 
                    II  Software  cannot determine efficiently the new 
                    location of the buffers. 
                    
                    If  you  are  using  DMA,  and you are running any 
                    memory  management   software,   set   the   LOMEM 
                    parameter   or  use  PIO  instead.  LOMEM  is  set 
                    automatically when you use the  WIN=31  or  WIN=30 
                    parameters,  but if you are using Windows, PIO may 
                    give  you  better  performance   (particularly  if 
                    your  system  has  fast clock- and bus-speeds). We 
                    recommend you experiment to find the method  which 
                    gives the best performance for your system.

IO.LOCATION         Specifies the location in computer memory of input 
                    to, and output from, the Ringnode.  The  Ringnodes 
                    in  the  expansion slots inside your computer each 
                    write to particular locations  in  the  computer's 
                    I/O  space.  If you have more than one Ringnode in 
                    your computer, you can use IO.LOCATION to  specify 
                    each  Ringnode  that  you configure. Otherwise the 
                    software uses a first-found algorithm:      
                    
                    It  finds  AT  Ringnodes  in ascending order of IO 
                    location.  For  example,  adapter  0a20  is  found 
                    before 1a20.

                    It finds EISA Ringnodes in ascending order of slot 
                    number.   The  IO  location of an EISA card is the 
                    slot number plus three zeroes.  For example,  slot 
                    4 is io location 4000.

                    It  finds  Micro-Channel  Ringnodes  at  addresses 
                    0a20,  1a20,  2a20, and 3a20 in ascending order of 
                    I/O location and before Micro-Channel Ringnodes at 
                    addresses 0e20, 1e20, 2e20, and 3e20.
                    
                    It finds AT Ringnodes before EISA  Ringnodes  when 
                    both  types  of Ringnode are installed in the same 
                    computer.
                    
                    It  does  not  find  PCI  Ringnodes.  The Smart II 
                    Software identifies and locates PCI  Ringnodes  by 
                    slot  number.  If you are using multiple Ringnodes 
                    one of which is  a  PCI  Ringnode,  use  the  SLOT 
                    parameter  (see  below)  for  that  Ringnode. (Use 
                    IO.LOCATION for the other Ringnodes).
                    
                    If the command line or  SMART.CFG  has  parameters 
                    for more than one Ringnode then these sections are 
                    applied  to  Ringnodes as the Ringnodes are found. 
                    You can use the IO LOCATION  parameter  to  change 
                    this  default  behaviour and force the software to 
                    apply  a  set  of  parameters  to   a   particular 
                    Ringnode.
                        
                    Abbreviation: IO
                    Example     : IO=3a20

SLOT                If  you  are  installing drivers for more than one 
                    adapter, then you can use the  SLOT  parameter  to 
                    associate  a  particular  [CARD]  section  with  a 
                    particular PCI Ringnode.  (For non-PCI  Ringnodes, 
                    use the IO.LOCATION parameter instead).
                     
                    If your computer's BIOS is compatible with version 
                    2.1  (or later) of the PCI specification, then set 
                    the SLOT parameter  to  the  number  of  the  slot 
                    containing   your   Ringnode.    (This  number  is 
                    displayed near the slot on the outside of the PC). 
                    
                    However,  if  you  do  not  have  a  BIOS  that is 
                    compatible   with   version   2.1   of   the   PCI 
                    specification,  or  if  you  do not know what slot 
                    number to use, we recommend  that  you  allow  the 
                    Smart  II  Software  to  load  onto  the different 
                    adapters in default order. This is because of  the 
                    possibility  that the slot number indicated on the 
                    outside of the computer, is not a number that  the 
                    network  drivers  can use to identify the Ringnode 
                    by.  
            
                    By default, the Smart II Software loads first onto 
                    the Ringnode in the slot that has the lowest  slot 
                    number, second, onto the Ringnode in the slot that 
                    has the second lowest slot number, and so on.  You 
                    can use the numbers on the outside of the PC as an 
                    indication of the slot with the lowest slot number 
                    (even  if  you can't rely on any of the numbers as 
                    parameter values).
                    
                    Example: SLOT=1
                                    
                    
USEDMA              This  parameter  disables  the detection of memory 
                    managers  by  the  Smart  II  Software.   If  your 
                    Ringnode supports DMA, this parameter causes it to 
                    perform DMA without copying data-transfers through 
                    a buffer in low memory. Use the LOMEM parameter as 
                    well,  if  you  want to ensure that data is copied 
                    through a buffer in low memory.     

ALTIO               This parameter is only available with the  "ASYNC" 
                    bus  mode.  If your computer has bus-compatibility 
                    problems with AT or ISA Client Ringnodes, use  the 
                    ALTIO  parameter  and  configure your Ringnode for 
                    PIO and alternate bus-timing.

MMIO                Enables the use  of  MMIO  (Memory  Mapped  Input/
                    Output) mode of data transfer on your ringnode (if 
                    available).  On  some  computers  this  may give a 
                    performance improvement over other transfer modes.
                    
FRAME.SIZE          This  parameter  controls the  maximum frame  size 
                    that protocol modules can use. The  maximum  value 
                    depends on which interfaces  are  enabled,  and on
                    which Ringnode  you are  running. By default,  the
                    maximum frame size possible (up to 4K) is used.

                    Note  that LLC.SMT has another parameter (RX.SIZE) 
                    which you can use to reduce the frame size for LLC 
                    applications. This parameter only affects the  LLC 
                    interface.

                    Table 2 shows default frame sizes  for  individual 
                    interfaces  and  combinations  of  interfaces on a 
                    128k Ringnode.   Ringnodes with 256k  or  512k  of 
                    RAM,  support  a  frame size of 4096 bytes for all 
                    allowable combinations of interfaces.           

                    --------------------------------------------------
                    | Interfaces enabled:      | Default frame size: |
                    --------------------------------------------------
                    | IPX                      | 4096                |
                    | ODI                      | 4096                |
                    | NetBIOS                  | 4096                |
                    | LLC and IPX              | 4096                |
                    | LLC and NetBIOS          | 1024                | 
                    | IPX and NetBIOS          | 1024                | 
                    | ODI and NetBIOS          | 4096                |
                    | TCP/IP                   | 1024                |
                    | NDIS                     | 4096                |
                    | NDIS + IPX               | 4096                |
                    --------------------------------------------------
                    Table 2 Default frame sizes

                    Range       : 200 - 17960
                    Abbreviation: FS

                    Example     : FS=1024

NODE.ADDRESS        The  node  address parameter allows you to specify 
                    the 6-byte node address to be used by the adapter.  
                    If you omit this parameter, the Ringnode uses  its 
                    unique  burnt-in  node  address.  We recommend the 
                    burnt-in address whenever possible. 
                    
                    You  can  specify  the  node  address  without   a 
                    keyword.  
                    
                    You  can  use  any valid hexadecimal number in the 
                    range 400000000000 to 7FFFFFFFFFFF.   
                    
                    Ensure  that  every  adapter in your network has a 
                    different node address. 

                    Range       : 400000000000 - 7FFFFFFFFFFF
                    Abbreviation: NA or (blank)
                    
                    Example     : NA=400012345678 or just 400012345678

SAPS                Specifies the maximum number of LLC Service Access 
                    Points (SAPs) that you can open at any  one  time. 
                    The NetBIOS and IPX interfaces each use one SAP.    
                    
                    Range       : 0 - 127  
                    Default     : 2
                    Abbreviation: SA

                    Example     : SA=27

EXTRA.SAPS          Specifies  the  number  of  extra  SAPs  that  are 
                    available for LLC applications, other than NetBIOS 
                    and IPX, to use. For example, you need one  for  a 
                    3270 attachment program.  The total number of SAPS 
                    and EXTRA.SAPS must not exceed 128.

                    Range       : 0 - 127  
                    Default     : 3
                    Abbreviation: ES

                    Example     : ES=27

GROUP.SAPS          Specifies  the  number  of  group  SAPs  that  are 
                    available for LLC applications. It is rare for  an
                    LLC application to use group SAPs.

                    Range       : 0 - 127  
                    Default     : 1
                    Abbreviation: GS

                    Example     : GS=8

STATIONS            Specifies   the   maximum   number  of  LLC  links 
                    (link-stations) that you can  open  at  one  time.  
                    The  total  value  of  STATIONS and EXTRA.STATIONS 
                    (see below), is the  total  number  of  LLC  links 
                    available.  
                    
                    If you enable the NetBIOS interface, NetBIOS  uses 
                    all  of  the  links  that  you  specify  with  the 
                    STATIONS parameter.  If you  disable  the  NetBIOS 
                    interface,  all  of  these  links are available to 
                    other LLC applications. 
        
                    Range       : 0 - 254  
                    Default     : 32
                    Abbreviation: ST

                    Example     : ST=27

EXTRA.STATIONS      Specifies  the  maximum  number of extra LLC links 
                    (link-stations)  that  you can  open at one  time. 
                    The  total  value  of  STATIONS  (see  above)  and 
                    EXTRA.STATIONS,  is  the  total  number  of  links 
                    available.
                    
                    NetBIOS uses all of the links you specify with the 
                    STATIONS  parameter.  Those that you specify using 
                    EXTRA.STATIONS  are  available   for   other   LLC 
                    applications. The default value of 3 allows you to 
                    use  an  LLC workstation application that requires 
                    one link. In addition, you can  use  the  2  other 
                    links  to  connect  to  a 3270 attachment program, 
                    AS400 direct attachment program, or to  a  bridge. 
                    The  total  number  of STATIONS and EXTRA.STATIONS 
                    must not exceed 255.
                    
                    Range       : 0 - 254  
                    Default     : 3
                    Abbreviation: EST

                    Example     : EST=27

DEF.MAXIN           Specifies the default number of I-frames that  are
                    received on LLC links before an acknowledgment  is 
                    sent.
                                                                        
                    Range       : 1 - 127
                    Default     : 1
                    Abbreviation: DMI
                                
                    Example     : DMI=5
                                        
DEF.MAXOUT          Specifies the default  number of I-frames that are
                    transmitted on LLC links before an  acknowledgment 
                    is required.
                                                                        
                    Range       : 1 - 127
                    Default     : 2
                    Abbreviation: DMO
                                
                    Example     : DMO=8
                                                                                                                                                                                                        
DEF.MAXOUT.INCR     Specifies the default  number of  frames by  which  
                    the  size  of  the  transmit window  increases  in 
                    response  to  a  frame loss caused by  a temporary 
                    congestion.                 

                    Range       : 1 - 255
                    Default     : 1
                    Abbreviation: DMOI

                    Example     : DMOI=20
                                                                                
DEF.RETRY.COUNT     Specifies the default number of attempts that  the 
                    LLC makes to transmit I-frames on links.
                                
                    Range       : 1 - 255
                    Default     : 10
                    Abbreviation: DRC

                    Example     : DRC=8
                                                                                                                
DEF.T1              Specifies the default delay  between  transmission 
                    and retransmission of a frame if no acknowledgment  
                    is received. 
                    
                    Range       : 0 - 10
                    Default     : 5
                    Abbreviation: DT1

                    Example     : DT1=8
                                                                                        
DEF.T2              Specifies the default time between the receipt and 
                    acknowledgment  of  a frame when the frame has not 
                    reached the receive  window.

                    Range       : 0 - 11
                    Default     : 2
                    Abbreviation: DT2

                    Example     : DT2=5
                                                                                                                                                
DEF.TI              Specifies  the  default delay after which the  LLC 
                    sends poll frames to check that a  link  is  still  
                    functional. 

                    Range       : 0 - 10
                    Default     : 10
                    Abbreviation: DTI
                                
                    Example     : DTI=7

IRQ                 If you are using the Smart 16 Ringnode,  use  this 
                    parameter  to configure the interrupt setting. The 
                    Smart 16 Ringnode uses  interrupt  3  by  default. 
                    Interrupts    2    and    7    are   provided   as 
                    alternatives. (You can also use this  parameter to 
                    force  your  PCMCIA  Ringnode  to use a particular 
                    interrupt. For  more  information,  refer  to  the 
                    User Documentation.
                    
                    Range       : 2, 3, or 7
                    Default     : 3
                    Abbreviation: None
                    
                    Example     : IRQ=2

ALTERNATE           Try using this parameter if  your  Ringnode  fails 
                    the  DIAG  tests,  and  you  think  this  might be 
                    because your computer is not fully ISA compatible.  
                            
                    Range       : None
                    Default     : Not set
                    Abbreviation: REV3
                    
                    Example     : ALTERNATE
                                                                
            
BURNT.IN.ADDRESS    Use this parameter to identify a  particular  plug
                    and play card.
                                        
                    Range       : Node Address
                    Default     : None
                    Abbreviation: BIA
                    
                    Example     : BIA=0000F6990019
                    

                    ***** End of SMTCARD.TXT *****


        
